## ros-noetic-dynamixel-workbench-controllers 2.2.1

=== CMakeLists.txt ===
################################################################################
# Set minimum required version of cmake, project name and compile options
################################################################################
cmake_minimum_required(VERSION 3.0.2)
project(dynamixel_workbench_controllers)

## Compile as C++11, supported in ROS Kinetic and newer
add_compile_options(-std=c++11)

################################################################################
# Find catkin packages and libraries for catkin and system dependencies
################################################################################
find_package(catkin REQUIRED COMPONENTS
  roscpp
  sensor_msgs
  geometry_msgs
  trajectory_msgs
  dynamixel_workbench_msgs
  dynamixel_workbench_toolbox
  cmake_modules
)

find_package(Eigen3 REQUIRED)

# Resolve system dependency on yaml-cpp, which apparently does not
# provide a CMake find_package() module.
find_package(PkgConfig REQUIRED)
pkg_check_modules(YAML_CPP REQUIRED yaml-cpp)
find_path(YAML_CPP_INCLUDE_DIR
  NAMES yaml_cpp.h
  PATHS ${YAML_CPP_INCLUDE_DIRS}
)
find_library(YAML_CPP_LIBRARY
  NAMES YAML_CPP
  PATHS ${YAML_CPP_LIBRARY_DIRS}
)
link_directories(${YAML_CPP_LIBRARY_DIRS})

if(NOT ${YAML_CPP_VERSION} VERSION_LESS "0.5")
add_definitions(-DHAVE_NEW_YAMLCPP)
endif(NOT ${YAML_CPP_VERSION} VERSION_LESS "0.5")

################################################################################
# Setup for python modules and scripts
################################################################################

################################################################################
# Declare ROS messages, services and actions
################################################################################

################################################################################
## Declare ROS dynamic reconfigure parameters
################################################################################

################################################################################
# Declare catkin specific configuration to be passed to dependent projects
################################################################################
catkin_package(
 INCLUDE_DIRS include
 CATKIN_DEPENDS roscpp sensor_msgs geometry_msgs dynamixel_workbench_msgs trajectory_msgs dynamixel_workbench_toolbox cmake_modules
 DEPENDS EIGEN3
)

################################################################################
# Build
################################################################################
include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${EIGEN3_INCLUDE_DIRS}
  ${YAML_CPP_INCLUDE_DIRS}
)

add_executable(dynamixel_workbench_controllers src/dynamixel_workbench_controllers.cpp src/trajectory_generator.cpp)
add_dependencies(dynamixel_workbench_controllers ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(dynamixel_workbench_controllers ${catkin_LIBRARIES} ${Eigen3_LIBRARIES} ${YAML_CPP_LIBRARIES})

add_executable(find_dynamixel src/find_dynamixel.cpp)
add_dependencies(find_dynamixel ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(find_dynamixel ${catkin_LIBRARIES})

#################################################################################
## Install
#################################################################################
install(TARGETS dynamixel_workbench_controllers find_dynamixel
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

install(DIRECTORY launch config
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

################################################################################
# Test
################################################################################

=== debian/changelog ===
ros-noetic-dynamixel-workbench-controllers (2.2.1-1focal) focal; urgency=high

  * Added 2XC430-W250, XL330 series
  * Contributors: Will Son, t-kitajima, Hye-jong KIM

 -- Will Son <willson@robotis.com>  Mon, 28 Jun 2021 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (2.2.0-1focal) focal; urgency=high

  * Added XW540
  * Bugs fixed, typos revised
  * Contributors: Ryan Shim, Yutaka Kondo, T-Kitajima, Nico Zevallos, Madhur Deep Jain, Will Son, YongHo Na

 -- Will Son <willson@robotis.com>  Thu, 24 Sep 2020 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (2.1.0-1focal) focal; urgency=high

  * Removed single_manager and single_manager_gui
  * Added XH540, PRO (A Firmware), RH_P12_RN, RH_P12_RN (A Firmware)
  * Contributors: Ryan Shim

 -- Will Son <willson@robotis.com>  Mon, 03 Jun 2019 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (2.0.0-1focal) focal; urgency=high

  * added YAML configuration for Dynamixel
  * supported position control mode, current based position control mode through Joint Trajectory Message
  * supported velocity control mode through Twist Message
  * reduced memory usage(Contribute by @KurtE)
  * updated API for sync, bulk instruction
  * updated control period (default is 10ms)
  * supported Linux, macos
  * supported Pro+
  * supported DynamixelSDK(after v.3.6.2)
  * supported OpenManipulator
  * Contributors: Darby Lim, KurtE, Pyo

 -- Will Son <willson@robotis.com>  Thu, 03 Jan 2019 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (1.0.0-1focal) focal; urgency=high

  * upgraded read time #162
  * added Dynamixel PRO information #162
  * added PROext header
  * Contributors: Darby Lim, Pyo

 -- Will Son <willson@robotis.com>  Thu, 19 Jul 2018 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (0.3.1-1focal) focal; urgency=high

  * none

 -- Will Son <willson@robotis.com>  Sun, 03 Jun 2018 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (0.3.0-1focal) focal; urgency=high

  * added cmd_vel topics, joint_state topics, msgs
  * changed compile options
  * deleted unused code
  * Merge pull request #152 <https://github.com/ROBOTIS-GIT/dynamixel-workbench/issues/152>  #151 <https://github.com/ROBOTIS-GIT/dynamixel-workbench/issues/151> #149 <https://github.com/ROBOTIS-GIT/dynamixel-workbench/issues/149> #132 <https://github.com/ROBOTIS-GIT/dynamixel-workbench/issues/132>
  * Contributors: Darby Lim, Pyo

 -- Will Son <willson@robotis.com>  Thu, 31 May 2018 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (0.2.4-1focal) focal; urgency=high

  * changed package.xml to format v2
  * Contributors: Pyo

 -- Will Son <willson@robotis.com>  Mon, 19 Mar 2018 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (0.2.3-1focal) focal; urgency=high

  * added dynamixel_sdk lib
  * added debug code
  * deleted anotation
  * Contributors: Darby Lim

 -- Will Son <willson@robotis.com>  Thu, 08 Mar 2018 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (0.2.2-1focal) focal; urgency=high

  * modified the CI configurations (#117 <https://github.com/ROBOTIS-GIT/dynamixel-workbench/issues/117>)
  * modified the CMakeLists.txt to fix wrong path (ros/rosdistro#17019 <https://github.com/ros/rosdistro/pull/17019>)
  * Contributors: Pyo

 -- Will Son <willson@robotis.com>  Tue, 27 Feb 2018 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (0.2.1-1focal) focal; urgency=high

  * None

 -- Will Son <willson@robotis.com>  Wed, 21 Feb 2018 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (0.2.0-1focal) focal; urgency=high

  * added blank
  * added linux build and example
  * added multi port example
  * modified bug
  * modified torque example
  * modified example
  * modified controllers
  * modified linux version
  * deleted build
  * deleted footnote
  * deleted annotation
  * Contributors: Darby Lim, Yoonseok Pyo

 -- Will Son <willson@robotis.com>  Sun, 18 Feb 2018 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (0.1.9-1focal) focal; urgency=high

  * modified dependency
  * Contributors: Darby Lim

 -- Will Son <willson@robotis.com>  Thu, 02 Nov 2017 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (0.1.8-1focal) focal; urgency=high

  * None

 -- Will Son <willson@robotis.com>  Tue, 31 Oct 2017 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (0.1.7-1focal) focal; urgency=high

  * added rospy for the issue https://github.com/ROBOTIS-GIT/dynamixel-workbench/issues/77
  * Contributors: Darby Lim

 -- Will Son <willson@robotis.com>  Sun, 29 Oct 2017 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (0.1.6-1focal) focal; urgency=high

  * updated annotation
  * updated controller cpp
  * updated profile function
  * updated torque control
  * updated read function
  * modified launch files
  * modified variable
  * added C++11
  * added pro condition
  * added multi port
  * added velocity and current control
  * added multi_driver
  * changed BSD license to Apache 2.0 license
  * Contributors: Darby Lim

 -- Will Son <willson@robotis.com>  Tue, 08 Aug 2017 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (0.1.5-1focal) focal; urgency=high

  * modified the cmake of toolbox
  * Contributors: Darby Lim

 -- Will Son <willson@robotis.com>  Mon, 22 May 2017 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (0.1.4-1focal) focal; urgency=high

  * added dynamixel new model: XL430_W250
  * added dynamixel new model: XH
  * renamed current controller -> torque controller
  * Contributors: Darby Lim, Dardy Lim

 -- Will Son <willson@robotis.com>  Sun, 23 Apr 2017 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (0.1.3-1focal) focal; urgency=high

  * update torque controller
  * add control parameters
  * modified ros nodehandle
  * Contributors: Darby Lim

 -- Will Son <willson@robotis.com>  Mon, 28 Nov 2016 15:00:00 -0000

ros-noetic-dynamixel-workbench-controllers (0.1.2-1focal) focal; urgency=high



=== debian/control ===
Source: ros-noetic-dynamixel-workbench-controllers
Section: misc
Priority: optional
Maintainer: Will Son <willson@robotis.com>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, libyaml-cpp-dev, ros-noetic-catkin, ros-noetic-cmake-modules, ros-noetic-dynamixel-workbench-msgs, ros-noetic-dynamixel-workbench-toolbox, ros-noetic-geometry-msgs, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-trajectory-msgs
Homepage: http://wiki.ros.org/dynamixel_workbench_controllers
Standards-Version: 3.9.2

Package: ros-noetic-dynamixel-workbench-controllers
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, libyaml-cpp-dev, ros-noetic-cmake-modules, ros-noetic-dynamixel-workbench-msgs, ros-noetic-dynamixel-workbench-toolbox, ros-noetic-geometry-msgs, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-trajectory-msgs
Description: This package contains examples of applying the 'dynamixel_workbench_toolbox' library developed on the basis of dynamixel_sdk to various operating modes of Dynamixel.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-dynamixel-workbench-controllers//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
